<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for 7.1.0 (7089)
 *
 *  - add tiles to sus forms
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update7089()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  if( FORCE || FORCE_6_1 || $localStore->GetBuild( 'folder.confdev' ) <= 7089 )  {
    printf( "Start Update #7089 (currentVersion=%d)\r\n", $accessBuild );
  
    for( $i = 0; $i < $localStore->Size( ); $i++ ) {
      // remove rule configuration
      $entityId = $localStore->GetEntityIdAt( $i );
      Update7089Sus( $entityId );
    }
  }
  else {
    printf( "Skip update #7089 Server version=%d\r\n", $accessBuild );
  }

}

/*-----------------------------------------------------------------------------
 *  ADD SUS tiles if needed
 */
function Update7089Sus( $entityId )
{
  global $localStore;
  $entity = $localStore->Get( $entityId );

  // only sus forms will be updated
  if( !isset( $entity['class'] ) || $entity['class'] != "susapp" ) {
    return;
  }

  // set correct device template
  $entity['deviceTemplate'] = "Siedle APP";

  // check how much tiles are already installed
  $numInstalledTiles = 0;
  foreach( $entity['deviceConfig'] as &$deviceRecord ) {
    if( isset( $deviceRecord['module'] ) &&  $deviceRecord['module'] == "SUS_TILE" )  {
      $numInstalledTiles++;
    }
  }

  // update the number of tiles to 44
  for( $numTile = $numInstalledTiles + 1; $numTile <= 44; $numTile++ )  {
    $currentTile = array(
      "module" => "SUS_TILE",
      "template" => "none",
      "modid" => 0,
      "uid" => "tile" . $numTile,
      "abbr" => "T" . $numTile,
      "trigger" => "single",
      "in" => array( "sysid" => 1 ),
    );
    array_push( $entity['deviceConfig'], $currentTile );

    $currentLed = array(
      "module" => "LED",
      "template" => "none",
      "modid" => 0,
      "uid" => "tile" . $numTile,
      "trigger" => "led",
      "led" => array( 
        array( 
          "sysid" => 1,
          "sysname" => "LD_tile"
        )
      )
    );
    array_push( $entity['deviceConfig'], $currentLed );

  }//for

  $localStore->Set( $entityId, $entity );

}
